#ifndef SCHEMA_H_
#define SCHEMA_H_

#include "iopclib/iopcHeaders.h"

using namespace iopc;
using namespace std;

class Person : public OidObject {
public:
	EShort age;
	EString name;
};

class Employee : public Person {
public:
	EInt salary;
};

class Student : public Person {
public:
	EString studcardid;
	DbPtr<Employee> supervisor;

	static void iopcInit(iopc::Type& t) {
		t["db.mapping.type"].setStringValue("horizontal");
	}
};
class PhdStudent : public Student {
public:
	EShort scholarship;

	static void iopcInit(iopc::Type& t) {
		t["db.mapping.type"].setStringValue("filtered");
		t["db.mapping.insertto"].setStringValue("::Student");
	}
};

#endif /*SCHEMA_H_*/
