/**
 * @file cursorImpl.h
 * 
 * @author Petr Cermak
 */

#ifndef CURSORIMPL_H_
#define CURSORIMPL_H_

#include "iopccommon/defs.h"
#include "iopcmeta/type.h"
#include "iopccommon/metadataHolder.h"

namespace iopc {

class  DLL_EXTERNAL CursorImpl {

public:
	virtual void open() = 0;
	virtual void close() = 0;
	virtual void prepare() = 0;
	virtual void preExecBind(const int pos, const void* varAddr, unsigned int size, const Type& varType, bool setNull, const MetadataHolder& attributes = MetadataHolder::emptyMeta) = 0;
	virtual void execute() = 0;
	virtual void preFetchBind(const int pos, const void* varAddr, unsigned int size, const Type& varType, bool* isNull = NULL, const MetadataHolder& attributes = MetadataHolder::emptyMeta) = 0;
	virtual bool fetchNext() = 0;
	virtual bool fetchPrev() = 0;
	virtual long getPosition() = 0;
	
	virtual ~CursorImpl() {};
};

}

#endif /*CURSORIMPL_H_*/
