#ifndef DATABASE_H_
#define DATABASE_H_

#include <string>
#include "iopccommon/defsPlatform.h"
#include "connection.h"
#include "databaseImpl.h"

namespace iopc {

class Connection;
class DatabaseImpl;
class Driver;


/**
 * @brief Interface of all Database objects
 * 
 * This abstract class specifies the interface which all Database  
 * 
 */
class DLL_EXTERNAL Database {

public:
	
	
	virtual Driver& getDriver() =0;
	
	/**
	 * Implementation should delete the inner instance
	 */
	virtual ~Database() {};
	
	virtual void commit() = 0;

	virtual void rollback()= 0;

	virtual Connection* getConnection(const std::string& connStr) = 0;

	virtual void returnConnection(Connection* connection) = 0;

	// TODO: returnAllConnections();

	virtual void disconnect() = 0;
	
	//inline virtual std::string& getConnectionString() { return connectionString; }
	
	virtual DatabaseImpl* getImplementation() = 0;

	/* TODO pokud bude potreba od Trocha
	static bool runAfterConnectHandler;
      	If \ref afterConnectHandler returns 0, \ref runAfterConnectHandler should be set to false.
	static int (* afterConnectHandler)(Connection * connection);
	*/
	
	virtual Database* getBasicDatabase() = 0;
	
}; // class


} // namespace

#endif /*DATABASE_H_*/
