#ifndef DRIVEREXTENSION_H_
#define DRIVEREXTENSION_H_

#include "iopccommon/defs.h"
#include <string>

namespace iopc {

class Driver;

class DLL_EXTERNAL DriverExtension
{
	friend class Driver;
protected:
	DriverExtension(const std::string& driverName, const std::string& name);
	virtual ~DriverExtension();
	
	virtual void doInit(Driver& driver) =0;
	
	inline std::string& getDriverName() { return driverName; }
	inline std::string& getName() { return name; }
private:
	std::string driverName;
	std::string name;
};


}

#endif /*DRIVEREXTENSION_H_*/
