#ifndef SIMPLESTRATSELECTOR_H_
#define SIMPLESTRATSELECTOR_H_

// project: POLiTe
// authors: Jan Hadrava 2004

/** \file */

#include <map>

#include "strategy.h"
#include "strategySelector.h"
#include "../persIdentification.h"
#include "iopccommon/defs.h"

namespace iopc {

/** Simple implementation of strategies selector. */
class DLL_EXTERNAL SimpleStrategySelector: public StrategySelector {
public:
	SimpleStrategySelector(void *wakeUpData, WakeUpMntrFunction wakeUpFunction, CostFunction costFunction);
	virtual ~SimpleStrategySelector();
private:/*hiding*/
	SimpleStrategySelector();
	SimpleStrategySelector(SimpleStrategySelector &);
	SimpleStrategySelector &operator=(SimpleStrategySelector &);
protected:
	typedef std::map<const Type*, Strategy*> StratMap;
	typedef StratMap::iterator Iter;
public:
	virtual const Strategy& select() const;
	virtual const Strategy& select(const PersIdentification& persId) const;
	/** Sets strategies for specified type. */
	void setStrategy(const Type& type, bool loadWait, bool loadLocking, UpdatingStrategy uStrat, ReadingStrategy rStrat);
	/** Sets strategies for all types. */
	void setStrategy(bool loadWait, bool loadLocking, UpdatingStrategy uStrat, ReadingStrategy rStrat);
	void offline();
protected:
	void setStrategyInternal(const Type* type, bool loadWait, bool loadLocking, UpdatingStrategy uStrat, ReadingStrategy rStrat);
	mutable StratMap stratMap;
	void* wakeUpData;
	WakeUpMntrFunction wakeUpFunction;
	CostFunction costFunction;
};

}/*namespace iopc*/

#endif /*SIMPLESTRATSELECTOR_H_*/
