#include "attribute.h"
#include "type.h"

using namespace std;
using namespace iopc;

Attribute::Attribute(const std::string& name, const Type& type, const AttributeVisibility visibility, const Type& owner)
: type(type), name(name), visibility(visibility), owner(owner)
{
	setSecondaryMetadataLocation(&type);
}

Attribute::Attribute(const Attribute& src)
: type(src.type), name(src.name), visibility(src.visibility), owner(src.owner)
{
	setSecondaryMetadataLocation(&type);
}

Attribute::Attribute(Attribute* const& src)
: type(src->type), name(src->name), visibility(src->visibility), owner(src->owner)
{
	setSecondaryMetadataLocation(&type);
}

