#ifndef ATTRIBUTE_H_
#define ATTRIBUTE_H_

#include "iopccommon/defs.h"
#include "iopccommon/metadataHolder.h"
#include <string>
#include <map>

namespace iopc {

class Type;

class DLL_EXTERNAL Attribute : public MetadataHolder{
public:	
	enum AttributeVisibility {
		VISIBILITY_PUBLIC,
		VISIBILITY_PROTECTED,
		VISIBILITY_PRIVATE
	};
	
	Attribute(const std::string& name, const Type& type, const AttributeVisibility visibility, const Type& owner);
	Attribute(const Attribute& src);
	// iopc::Attribute::Attribute(iopc::Attribute* const&)'
	Attribute(Attribute* const& src);
	//Attribute& operator=(const Attribute& src) { type = src.type; name = src.name; visibility = src.visibility; return *this;};
	
	inline const std::string getName() const { return name; };
	inline const Type& getType() const { return type; };
	inline const AttributeVisibility getVisibility() const { return visibility; };
	inline const Type& getOwner() const { return owner; }
	
	/*bool hasMeta(const std::string& key) const;
	inline std::string& operator[](const std::string& key) const { return meta[key]; };*/
	
private:
	/**
	 * Map containing metadata
	 */
//	mutable std::map<std::string, std::string> meta;
	const Type& type;
	const std::string name;
	const AttributeVisibility visibility;
	const Type& owner;
};

}


#endif /*ATTRIBUTE_H_*/
